//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3E9D6755006A.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3E9D6755006A.cm

//## begin module%3E9D6755006A.cp preserve=no
//## end module%3E9D6755006A.cp

//## Module: FunctionUtility%3E9D6755006A; Package body
//## Subsystem: XSUtil::FunctionUtils%48DBCC590164
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSUtil/FunctionUtils/FunctionUtility.cxx

//## begin module%3E9D6755006A.additionalIncludes preserve=no
//## end module%3E9D6755006A.additionalIncludes

//## begin module%3E9D6755006A.includes preserve=yes
//## end module%3E9D6755006A.includes

// FunctionUtility
#include <XSUtil/FunctionUtils/FunctionUtility.h>
//## begin module%3E9D6755006A.declarations preserve=no
//## end module%3E9D6755006A.declarations

//## begin module%3E9D6755006A.additionalDeclarations preserve=yes
#include <XSUtil/Utils/XSstream.h>
#include <XSUtil/Utils/IosHolder.h>
#include <XSUtil/Utils/XSutility.h>
#include "xsTypes.h"
#include <fstream>
#include <sstream>
#include <exception>
//## end module%3E9D6755006A.additionalDeclarations


// Class FunctionUtility::NoInitializer 

FunctionUtility::NoInitializer::NoInitializer()
  //## begin NoInitializer::NoInitializer%3E9D81750275_const.initialization preserve=yes
  : YellowAlert()
  //## end NoInitializer::NoInitializer%3E9D81750275_const.initialization
{
  //## begin FunctionUtility::NoInitializer::NoInitializer%3E9D81750275_const.body preserve=yes
  //## end FunctionUtility::NoInitializer::NoInitializer%3E9D81750275_const.body
}

FunctionUtility::NoInitializer::NoInitializer (const string& diag)
  //## begin FunctionUtility::NoInitializer::NoInitializer%3E9D81900134.hasinit preserve=yes
  : YellowAlert(" No Initializer for ")
  //## end FunctionUtility::NoInitializer::NoInitializer%3E9D81900134.hasinit
  //## begin FunctionUtility::NoInitializer::NoInitializer%3E9D81900134.initialization preserve=yes
  //## end FunctionUtility::NoInitializer::NoInitializer%3E9D81900134.initialization
{
  //## begin FunctionUtility::NoInitializer::NoInitializer%3E9D81900134.body preserve=yes
  *IosHolder::errHolder() << diag << '\n';
  //## end FunctionUtility::NoInitializer::NoInitializer%3E9D81900134.body
}


// Class FunctionUtility::InvalidAbundanceFile 

FunctionUtility::InvalidAbundanceFile::InvalidAbundanceFile (const string& diag)
  //## begin FunctionUtility::InvalidAbundanceFile::InvalidAbundanceFile%3E9DC8F1036C.hasinit preserve=yes
  : YellowAlert(" Invalid Abundance File ")
  //## end FunctionUtility::InvalidAbundanceFile::InvalidAbundanceFile%3E9DC8F1036C.hasinit
  //## begin FunctionUtility::InvalidAbundanceFile::InvalidAbundanceFile%3E9DC8F1036C.initialization preserve=yes
  //## end FunctionUtility::InvalidAbundanceFile::InvalidAbundanceFile%3E9DC8F1036C.initialization
{
  //## begin FunctionUtility::InvalidAbundanceFile::InvalidAbundanceFile%3E9DC8F1036C.body preserve=yes
  *IosHolder::errHolder() << diag << '\n';
  //## end FunctionUtility::InvalidAbundanceFile::InvalidAbundanceFile%3E9DC8F1036C.body
}


// Class FunctionUtility::FunctionException 

FunctionUtility::FunctionException::FunctionException (const string& diag)
  //## begin FunctionUtility::FunctionException::FunctionException%3FFEC7DE005D.hasinit preserve=yes
  : YellowAlert(" in function ")
  //## end FunctionUtility::FunctionException::FunctionException%3FFEC7DE005D.hasinit
  //## begin FunctionUtility::FunctionException::FunctionException%3FFEC7DE005D.initialization preserve=yes
  //## end FunctionUtility::FunctionException::FunctionException%3FFEC7DE005D.initialization
{
  //## begin FunctionUtility::FunctionException::FunctionException%3FFEC7DE005D.body preserve=yes
  *IosHolder::errHolder() << diag << std::endl;
  //## end FunctionUtility::FunctionException::FunctionException%3FFEC7DE005D.body
}


// Class FunctionUtility::Cosmology 

FunctionUtility::Cosmology::Cosmology ()
  //## begin FunctionUtility::Cosmology::Cosmology%40A4F6EF0004.hasinit preserve=yes
  : H0(.0), q0(.0), lambda0(.0)
  //## end FunctionUtility::Cosmology::Cosmology%40A4F6EF0004.hasinit
  //## begin FunctionUtility::Cosmology::Cosmology%40A4F6EF0004.initialization preserve=yes
  //## end FunctionUtility::Cosmology::Cosmology%40A4F6EF0004.initialization
{
  //## begin FunctionUtility::Cosmology::Cosmology%40A4F6EF0004.body preserve=yes
  //## end FunctionUtility::Cosmology::Cosmology%40A4F6EF0004.body
}


// Class Utility FunctionUtility 

//## begin FunctionUtility::XSECT%3E9D6704026E.attr preserve=no  public: static string {U} "bcmc"
string FunctionUtility::s_XSECT = "bcmc";
//## end FunctionUtility::XSECT%3E9D6704026E.attr

//## begin FunctionUtility::ABUND%3E9D67310032.attr preserve=no  public: static string {U} "angr"
string FunctionUtility::s_ABUND = "angr";
//## end FunctionUtility::ABUND%3E9D67310032.attr

//## begin FunctionUtility::CROSSSECTFILE%3E9D84B100FC.attr preserve=no  private: static string {UC} "crosssections.dat"
const string FunctionUtility::CROSSSECTFILE = "crosssections.dat";
//## end FunctionUtility::CROSSSECTFILE%3E9D84B100FC.attr

//## begin FunctionUtility::abundanceFile%3E9D84E5038E.attr preserve=no  public: static string {U} "abundances.dat"
string FunctionUtility::s_abundanceFile = "abundances.dat";
//## end FunctionUtility::abundanceFile%3E9D84E5038E.attr

//## begin FunctionUtility::elements%3E9D902602B7.attr preserve=no  private: static std::vector<string> {U} 
std::vector<string> FunctionUtility::s_elements;
//## end FunctionUtility::elements%3E9D902602B7.attr

//## begin FunctionUtility::managerPath%3E9D99B702CA.attr preserve=no  public: static string {U} ""
string FunctionUtility::s_managerPath = "";
//## end FunctionUtility::managerPath%3E9D99B702CA.attr

//## begin FunctionUtility::NELEMS%3E9DC11402BD.attr preserve=no  public: static size_t {UC} 30
const size_t FunctionUtility::s_NELEMS = 30;
//## end FunctionUtility::NELEMS%3E9DC11402BD.attr

//## begin FunctionUtility::modelDataPath%3F96E98A01F0.attr preserve=no  public: static string {U} ""
string FunctionUtility::s_modelDataPath = "";
//## end FunctionUtility::modelDataPath%3F96E98A01F0.attr

//## begin FunctionUtility::NOT_A_KEY%3F981CF702CD.attr preserve=no  public: static string {U} "$$NOT$$"
string FunctionUtility::s_NOT_A_KEY = "$$NOT$$";
//## end FunctionUtility::NOT_A_KEY%3F981CF702CD.attr

//## begin FunctionUtility::COSMO%40A4F76D0000.attr preserve=no  private: static FunctionUtility::Cosmology {U} FunctionUtility::Cosmology()
FunctionUtility::Cosmology FunctionUtility::s_COSMO = FunctionUtility::Cosmology();
//## end FunctionUtility::COSMO%40A4F76D0000.attr

//## begin FunctionUtility::abundPath%41B9C798029D.attr preserve=no  public: static string {U} 
string FunctionUtility::s_abundPath;
//## end FunctionUtility::abundPath%41B9C798029D.attr

//## begin FunctionUtility::abundChanged%41B9C7C10227.attr preserve=no  public: static bool {U} false
bool FunctionUtility::s_abundChanged = false;
//## end FunctionUtility::abundChanged%41B9C7C10227.attr

//## begin FunctionUtility::xwriteChatter%44B413B30272.attr preserve=no  public: static int {U} 10
int FunctionUtility::s_xwriteChatter = 10;
//## end FunctionUtility::xwriteChatter%44B413B30272.attr

//## begin FunctionUtility::tempsDEM%48E3A2E303DD.attr preserve=no  public: static std::vector<double> {U} 
std::vector<double> FunctionUtility::s_tempsDEM;
//## end FunctionUtility::tempsDEM%48E3A2E303DD.attr

//## begin FunctionUtility::DEM%48E3A37F0042.attr preserve=no  public: static std::vector<double> {U} 
std::vector<double> FunctionUtility::s_DEM;
//## end FunctionUtility::DEM%48E3A37F0042.attr

//## begin FunctionUtility::abundanceVectors%3E9D7EA503D7.role preserve=no  public: std::vector< float > { -> 1..nVHgN}
std::map<string,std::vector< float > > FunctionUtility::s_abundanceVectors;
//## end FunctionUtility::abundanceVectors%3E9D7EA503D7.role


//## begin FunctionUtility::crossSections%3E9D80840310.role preserve=no  public: std::string { -> 1..nRHN}
std::map<string,std::string> FunctionUtility::s_crossSections;
//## end FunctionUtility::crossSections%3E9D80840310.role


//## begin FunctionUtility::abundDoc%3E9DD208014F.role preserve=no  public: std::string { -> 1RHN}
std::map<string,std::string> FunctionUtility::s_abundDoc;
//## end FunctionUtility::abundDoc%3E9DD208014F.role


//## begin FunctionUtility::modelStringDataBase%3F98098C00CC.role preserve=no  public: std::string { -> 1..nVHgN}
std::map<string,std::string> FunctionUtility::s_modelStringDataBase;
//## end FunctionUtility::modelStringDataBase%3F98098C00CC.role



//## Other Operations (implementation)
bool FunctionUtility::checkXsect (const string& arg)
{
  //## begin FunctionUtility::checkXsect%3E9D7DBE00A8.body preserve=yes
  try
  {
        const string& table = crossSections(arg);       
  }
  catch (NoInitializer)
  {
        return false;       
  }                
        
  return true;
  //## end FunctionUtility::checkXsect%3E9D7DBE00A8.body
}

bool FunctionUtility::checkAbund (const string& arg)
{
  //## begin FunctionUtility::checkAbund%3E9D7DF901A0.body preserve=yes
  try
  {
        const std::vector<float>& element = abundanceVectors(arg);       
  }
  catch (NoInitializer)
  {
        return false;       
  }                
        
  return true;
  //## end FunctionUtility::checkAbund%3E9D7DF901A0.body
}

void FunctionUtility::readInitializers (string& xsects, string& abunds)
{
  //## begin FunctionUtility::readInitializers%3E9D84820256.body preserve=yes
        
  using namespace std;

  s_abundPath = s_managerPath;

  string fullAbundPath = s_abundPath + string("/") + s_abundanceFile;
  string fullXsectPath = s_managerPath + string("/") + CROSSSECTFILE;

  static const string NULLCHARS(" \t");
  s_elements.reserve(s_NELEMS);
  
  ifstream abund(fullAbundPath.c_str());    
  abund.exceptions(ios_base::failbit);
  
  abunds = "[ ";
  
  try
  {
        string element;
        abund.ignore(256,':');
        string abundLine("");
        getline(abund,abundLine);
        istringstream abundString(abundLine);
        while ( abundString >> element )
        {
                s_elements.push_back(element);     
        }
        
        bool readingStrings(false);
        while (abund)
        {
                string rawLine("");
                getline(abund, rawLine);       
                vector<float> abundances;
                abundances.reserve(s_NELEMS);
                int first(rawLine.find_first_not_of(NULLCHARS));
                if (first > 0 )rawLine = rawLine.substr(first);
                if ( rawLine.length() != 0 && first != -1)
                {
                        // ignore lines with '#' comment mark as first significant 
                        // character.
                        if ( rawLine[0] == '#') continue;
                        // ignore lines that do not meet syntax specification 
                        // (no delimiter)
                        int delim = rawLine.find_first_of(":");
                        if (delim < 0 ) continue;
                        string abundKey(rawLine.substr(0,rawLine.substr(0,delim).
                                                                find_last_not_of(NULLCHARS)+1));
                        
                        if (abundKey == "References")
                        {
                                readingStrings = true;
                                continue;       
                        }
                        
                        if ( !readingStrings )
                        {
                                abunds += abundKey + " | ";
                                string abundData(rawLine.substr(delim+1));
                                istringstream abVector(abundData);
                                float elementAbundance(0);
                                while (abVector >> elementAbundance)
                                {
                                        abundances.push_back(elementAbundance);      
                                }
                                abundanceVectors(abundKey,abundances);
                        }
                        else
                        {
                        	string descript(rawLine.substr(delim+1));
                                abundDoc(abundKey,descript);
                        }
                }
        }
  }
  catch ( std::exception& )
  {

        if ( !abund.eof())
        {
                string diag = "Cannot read abundance file " + s_abundanceFile
                        + "\n*** in XSPEC data file path (" 
                        + s_managerPath  + ")... exiting\n" ;                            
                throw RedAlert(diag);
        }
  }               
 
  
  abunds = abunds.substr(0,abunds.size()-2);
  abunds += "]";
  
  ifstream xsect(fullXsectPath.c_str());   
  xsect.exceptions(ios_base::failbit);
  
  xsects = "[ ";
  try
  {
        string rawLine("");
        while (getline(xsect,rawLine))
        {
                int first(rawLine.find_first_not_of(NULLCHARS));
                if (first > 0 )rawLine = rawLine.substr(first);
                if ( rawLine.length() != 0 && first != -1)
                {
                        // ignore lines with '#' comment mark as first significant 
                        // character.
                        if ( rawLine[0] == '#') continue;
                        // ignore lines that do not meet syntax specification 
                        // (no delimiter)
                        int delim = rawLine.find_first_of(":");
                        if (delim < 0 ) continue;
                        string table(rawLine.substr(0,rawLine.substr(0,delim).
                                                                find_last_not_of(NULLCHARS)+1));
                        xsects += table + " | ";
                        string descript(rawLine.substr(delim+1));
                        crossSections(table,descript);
                }
        }
  }
  catch ( std::exception& )
  {

        if ( !xsect.eof())
        {
                string diag = "Cannot read cross section table file " 
                                + CROSSSECTFILE
                                + "\n*** in XSPEC data file path (" 
                                + s_managerPath  + ")... exiting\n" ;                            
                throw RedAlert(diag);
        }
  }     
  
  xsects = xsects.substr(0,xsects.size()-2);
  xsects += "]";

            
          
  //## end FunctionUtility::readInitializers%3E9D84820256.body
}

void FunctionUtility::readNewAbundances (const string& file)
{
  //## begin FunctionUtility::readNewAbundances%3E9D85010265.body preserve=yes
  using namespace std;
  const string name("file");

  s_abundChanged = true;
  s_abundanceFile = file;
  s_abundPath = XSutility::getRunPath();
  
  ifstream newAbundanceFile(file.c_str());
  
  vector<float> newVector(s_NELEMS,0);
  size_t count(0);
  try
  {
        float element;
        newAbundanceFile.exceptions(ios_base::failbit);
        while (count < s_NELEMS && newAbundanceFile >> element)
        {
                newVector[count] = element;
		++count;
        }    
	ABUND(name);
        abundanceVectors(name,newVector);
        
  }
  catch ( std::exception& )
  {
        if (!newAbundanceFile.eof())
        {
                string diag(file);
                diag += "\nCannot be read from. Either it does not exist or contains invalid data";
                throw InvalidAbundanceFile(diag);       
        }       
          
  }     
  
  if (count < s_NELEMS)
  {
        // write a warning to the logfile if file is short.        
     if (XSstream* xscout = dynamic_cast<XSstream*>(IosHolder::outHolder()))
     {
        XSstream::verbose(*xscout,0,20);
        *xscout << "\n*** Warning: new element vector has fewer elements than allowed."
              << "\n*** heavier nuclei set with abundance 0" << std::endl;       
        XSstream::verbose(*xscout);
     }
  } 
        
  //## end FunctionUtility::readNewAbundances%3E9D85010265.body
}

float FunctionUtility::getAbundance (const string& element)
{
  //## begin FunctionUtility::getAbundance%3E9D957703C6.body preserve=yes
  std::vector<string>::iterator f = std::find(s_elements.begin(),s_elements.end(),element);
  
  if ( f == s_elements.end() ) 
  {
        *IosHolder::errHolder() << "XSPEC::getAbundance: Invalid element: " << element << " entered, returning 0.\n" ;
        return 0;  
  }     
  else
  {
#ifndef STD_COUNT_DEFECT
        size_t index(std::distance(s_elements.begin(),f));
#else
        size_t index(0);
	std::distance(s_elements.begin(),f,index);
#endif
          
          
          
        const std::vector<float>& abVector = abundanceVectors(s_ABUND);
        return abVector[index];        
  }
  //## end FunctionUtility::getAbundance%3E9D957703C6.body
}

const string& FunctionUtility::elements (size_t index)
{
  //## begin FunctionUtility::elements%3E9F155A01F5.body preserve=yes
  //## end FunctionUtility::elements%3E9F155A01F5.body

  return s_elements[index];
}

const string& FunctionUtility::getModelString (const string& key)
{
  //## begin FunctionUtility::getModelString%3F980A720395.body preserve=yes
  std::map<string,string>::iterator f(s_modelStringDataBase.find(key));
  return ( f != s_modelStringDataBase.end() ? f->second : s_NOT_A_KEY );
  //## end FunctionUtility::getModelString%3F980A720395.body
}

void FunctionUtility::setModelString (const string& key, const string& value)
{
  //## begin FunctionUtility::setModelString%3F9814320378.body preserve=yes
  if (!value.length())
  {
     std::map<string,string>::iterator itString =
                s_modelStringDataBase.find(key);
     if (itString != s_modelStringDataBase.end())
        s_modelStringDataBase.erase(itString);
  }
  else
     s_modelStringDataBase[key] = value;
  //## end FunctionUtility::setModelString%3F9814320378.body
}

void FunctionUtility::eraseModelStringDataBase ()
{
  //## begin FunctionUtility::eraseModelStringDataBase%40859D5E02EB.body preserve=yes
  s_modelStringDataBase.clear();
  //## end FunctionUtility::eraseModelStringDataBase%40859D5E02EB.body
}

void FunctionUtility::setFunctionCosmoParams (double H0, double q0, double lambda0)
{
  //## begin FunctionUtility::setFunctionCosmoParams%40A51AF0021C.body preserve=yes
  s_COSMO.H0 = static_cast<float>(H0);
  s_COSMO.q0 = static_cast<float>(q0);
  s_COSMO.lambda0 = static_cast<float>(lambda0);
  //## end FunctionUtility::setFunctionCosmoParams%40A51AF0021C.body
}

//## Get and Set Operations for Class Attributes (implementation)

void FunctionUtility::XSECT (const string& value)
{
  //## begin FunctionUtility::XSECT%3E9D6704026E.set preserve=yes
  *IosHolder::outHolder() << " Cross Section Table set to " << value << ": " 
                  << s_crossSections[value] << std::endl;
  s_XSECT = value;
  //## end FunctionUtility::XSECT%3E9D6704026E.set
}

void FunctionUtility::ABUND (const string& value)
{
  //## begin FunctionUtility::ABUND%3E9D67310032.set preserve=yes
  *IosHolder::outHolder() << " Solar Abundance Vector set to " << value 
        << ": " <<  abundDoc(value) << std::endl;
  s_ABUND = value;
  //## end FunctionUtility::ABUND%3E9D67310032.set
}

//## Get and Set Operations for Associations (implementation)

const std::vector< float >& FunctionUtility::abundanceVectors (string table)
{
  //## begin FunctionUtility::abundanceVectors%3E9D7EA503D7.qualget preserve=yes
  std::map<string,std::vector<float> >::iterator f(s_abundanceVectors.find(table));
  
  if ( f == s_abundanceVectors.end())
  {
        // throw quietly to allow this to be caught and the program control
        // sent on to try to read abundance from a file.
        throw NoInitializer();       
  }
  
  return f->second;
  //## end FunctionUtility::abundanceVectors%3E9D7EA503D7.qualget
}

const std::string& FunctionUtility::crossSections (string table)
{
  //## begin FunctionUtility::crossSections%3E9D80840310.qualget preserve=yes
  std::map<string,string>::iterator f(s_crossSections.find(table));
  
  if ( f == s_crossSections.end())
  {
        string diag = " cross section table named "  + table;
        throw NoInitializer(diag);       
  }
  
  return f->second;
  //## end FunctionUtility::crossSections%3E9D80840310.qualget
}

const std::string FunctionUtility::abundDoc (string name)
{
  //## begin FunctionUtility::abundDoc%3E9DD208014F.qualget preserve=yes
  std::map<string,string>::iterator f(s_abundDoc.find(name));
  
  if ( f == s_abundDoc.end())
  {
        string doc(" User defined abundance vector / no description specified");
        return doc; 
  }
  else return f->second;
  //## end FunctionUtility::abundDoc%3E9DD208014F.qualget
}

// Additional Declarations
  //## begin FunctionUtility%3E9D6558038D.declarations preserve=yes
  //## end FunctionUtility%3E9D6558038D.declarations

//## begin module%3E9D6755006A.epilog preserve=yes
//## end module%3E9D6755006A.epilog
